#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <asm/prom.h>
#include <linux/avm_hw_config.h>

/*------------------------------------------------------------------------------------------*\
 * FRITZ!Box Bene           
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config avm_hardware_config_hw161[] = {
    { .name = NULL }
};
EXPORT_SYMBOL(avm_hardware_config_hw161);


/*------------------------------------------------------------------------------------------*\
 * FRITZ!Box Fon WLAN 7320           
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config avm_hardware_config_hw172[] = {
    { .name = "gpio_avm_dect_reset", .value = 54 },
    { .name = NULL }
};
EXPORT_SYMBOL(avm_hardware_config_hw172);


/*------------------------------------------------------------------------------------------*\
 * FRITZ!Box Fon WLAN 7313           
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config avm_hardware_config_hw178[] = {
    { .name = "gpio_avm_dect_reset", .value = 54 },
    { .name = NULL }
};
EXPORT_SYMBOL(avm_hardware_config_hw178);


/*------------------------------------------------------------------------------------------*\
 * FRITZ!Box Fon WLAN 7330           
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config avm_hardware_config_hw179[] = {
    { .name = "gpio_avm_dect_reset", .value = 54 },
    { .name = NULL }
};
EXPORT_SYMBOL(avm_hardware_config_hw179);



/*------------------------------------------------------------------------------------------*\
 * FRITZ!Box Fon WLAN 7330 SL
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config avm_hardware_config_hw188[] = {
    { .name = "gpio_avm_dect_reset", .value = 54 },
    { .name = NULL }
};
EXPORT_SYMBOL(avm_hardware_config_hw188);



/*------------------------------------------------------------------------------------------*\
 * FRITZ!Box Fon WLAN 7312           
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config avm_hardware_config_hw189[] = {
    { .name = "gpio_avm_dect_reset", .value = 54 },
    { .name = NULL }
};
EXPORT_SYMBOL(avm_hardware_config_hw189);



/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config_table avm_hw_config_tables[] = {
    { 161, avm_hardware_config_hw161 }, /*--- FRITZ!Box Bene ---*/
    { 172, avm_hardware_config_hw172 }, /*--- FRITZ!Box Fon WLAN 7320 ---*/
    { 178, avm_hardware_config_hw178 }, /*--- FRITZ!Box Fon WLAN 7313 ---*/
    { 179, avm_hardware_config_hw179 }, /*--- FRITZ!Box Fon WLAN 7330 ---*/
    { 188, avm_hardware_config_hw188 }, /*--- FRITZ!Box Fon WLAN 7330 SL ---*/
    { 189, avm_hardware_config_hw189 }, /*--- FRITZ!Box Fon WLAN 7312 ---*/
};
EXPORT_SYMBOL(avm_hw_config_tables);



/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
struct _avm_hw_config *avm_current_hw_config = NULL;
EXPORT_SYMBOL(avm_current_hw_config);

struct _avm_hw_config *avm_get_hw_config_table(void)
{
    unsigned int hwrev, i;
    char *s;

    s = prom_getenv("HWRevision");
    if (s) {
        hwrev = simple_strtoul(s, NULL, 10);
    }     
    if((s == NULL) || (hwrev < 0) || (hwrev > 255)) {
        printk("[%s] error: %s HWRevision detected in environment variables: %s\n", __FUNCTION__, (s ? "invalid" : "no"), s);
        BUG_ON(1);
        return NULL;
    }
    for(i = 0; i < sizeof(avm_hw_config_tables)/sizeof(struct _avm_hw_config *); i++) {
        if(avm_hw_config_tables[i].hwrev == hwrev) 
            return avm_hw_config_tables[i].table;
    }
    printk("[%s] error: No hardware configuration defined for HWRevision %d\n", __FUNCTION__, hwrev);
    BUG_ON(1);
    return NULL;
}
EXPORT_SYMBOL(avm_get_hw_config_table);

