/*------------------------------------------------------------------------------------------*\
 *   Copyright (C) 2006,2007, ... ,2011 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
\*------------------------------------------------------------------------------------------*/


#ifndef _CPMAC_AR9_IF_H_
#define _CPMAC_AR9_IF_H_

#if defined(CONFIG_AR9) || defined(CONFIG_VR9)

#if defined(CONFIG_AR9)
#include <ifx_gpio.h>
/* Functions provided by the AR9 ethernet driver */
void ar9_switch_write_mdio(unsigned int uPhyAddr, unsigned int uRegAddr,unsigned int data);
unsigned short ar9_switch_read_mdio(unsigned int uPhyAddr, unsigned int uRegAddr);
void ar9_switch_write(unsigned int uRegAddr, unsigned int data);
unsigned int ar9_switch_read(unsigned int uRegAddr);
void ar9_setup_ext_phy_reset(int gpio, unsigned char en);
void reset_ext_gphy(int gpio);
#endif /*--- #if defined(CONFIG_AR9) ---*/

#if defined(CONFIG_VR9)
void vr9_switch_write_mdio(unsigned int phyAddr, unsigned int regAddr, unsigned int data);
unsigned short vr9_switch_read_mdio(unsigned int uPhyAddr, unsigned int uRegAddr);
void vr9_switch_write(unsigned int uRegAddr, unsigned int data);
unsigned int vr9_switch_read(unsigned int uRegAddr);
void ifx_avm_7port_power_ctrl(unsigned char phy_addr, unsigned char power_on);
void ifx_avm_7port_speed_throttle(unsigned char port, unsigned char do_throttle);
#endif /*--- #if defined(CONFIG_VR9) ---*/

extern void cpmac_ar9_if_rx(struct sk_buff *skb) __attribute__ ((weak));
extern void cpmac_ar9_set_dev(struct net_device *dev) __attribute__ ((weak));
extern void cpmac_ar9_open(struct net_device *dev) __attribute__ ((weak));
extern int cpmac_ar9_ioctl(struct net_device *dev,
                           struct ifreq *ifr,
                           int cmd) __attribute__ ((weak));
void cpmac_ar9_set_port_speed(unsigned char port,
                              unsigned char speed,
                              unsigned char fullduplex);
#endif /*--- #if defined(CONFIG_AR9) || defined(CONFIG_VR9) ---*/

#endif /*--- #ifndef _CPMAC_AR9_IF_H_ ---*/


