/*------------------------------------------------------------------------------------------*\
 *   Copyright (C) 2006,2007, ... ,2011 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
\*------------------------------------------------------------------------------------------*/


#ifndef _CPPHY_ADM6996_H_
#define _CPPHY_ADM6996_H_

#include <linux/avm_cpmac.h>
#include "cpmac_main.h"

/* Interprete four bits of the VID as VID group (FID) starting from bit given here */
#define ADM_6996_TAGSHIFT 8
#define ADM_GET_TAG_GROUP(x) (((x) >> ADM_6996_TAGSHIFT) & 0xf)

#define ADM_GET_SERIAL_REG(phy_number, addr) adm_read_32Bit_cached((phy_number), (addr))
#define ADM_GET_EEPROM_REG adm_read
/*--- #define ADM_GET_EEPROM_REG adm_safe_read ---*/
#define ADM_PUT_EEPROM_REG(phy_number, addr, dat) adm_write((phy_number), (addr), (dat))

unsigned int adm_read_32Bit_cached(phy_number_t phy_number, unsigned int addr);
unsigned short adm_read(phy_number_t phy_number, unsigned short addr);
unsigned int adm_read_32(phy_number_t phy_number, unsigned int addr);
unsigned short tantos_read(phy_number_t phy_number, unsigned short *ptr);
void adm_update_error_status(phy_number_t phy_number, unsigned char port);
void adm_update_cache(phy_number_t phy_number);
int adm_write(phy_number_t phy_number, unsigned short addr, unsigned short dat);
int adm_write_32(phy_number_t phy_number, unsigned int addr, unsigned int dat);
void adm_prepare_reboot(phy_number_t phy_number);
void switch_dump_adm6996(phy_number_t phy_number);
void switch_dump_tantos(phy_number_t phy_number);
#if defined(CONFIG_AR9)
void switch_dump_tantos_ar9(cpphy_mdio_t *mdio);
#endif /*--- #if defined(CONFIG_AR9) ---*/
unsigned long switch_dump(void);
void adm_adm6996xc_init(phy_number_t phy_number);
void adm_tantos_init(phy_number_t phy_number);
unsigned int adm_6996xc_check_link(phy_number_t phy_number);
unsigned int adm_tantos_check_link(phy_number_t phy_number);
void adm_switch_port_power_6996(phy_number_t phy_number,
                                unsigned char port, 
                                unsigned char power_on);
void adm_switch_port_power_tantos(phy_number_t phy_number,
                                  unsigned char port, 
                                  unsigned char power_on);
void adm_switch_wan_keep_tagging_adm6996(phy_number_t phy_number, unsigned char port);
void adm_switch_wan_keep_tagging_ar8x16(phy_number_t phy_number, unsigned char port);
unsigned long adm_set_wan_keep_tagging(cpphy_mdio_t *mdio);
cpmac_err_t adm_set_mode_pppoa(cpphy_mdio_t *mdio, unsigned int enable_pppoa);
void adm_vlan_fbox_reset(phy_number_t phy_number);
void adm_set_good_vid_bitshift(phy_number_t phy_number, struct avm_cpmac_config_struct *config);
unsigned char cpphy_adm_get_bitcombination(cpphy_mdio_t *mdio, unsigned char device);
void adm_adm6996_config_vlan_group(phy_number_t    phy_number,
                                   unsigned short  vid,
                                   unsigned short  portset,
                                   unsigned short  tagged_portset,
                                   unsigned char   port,
                                   unsigned char   FID,
                                   unsigned char   use_as_default);
unsigned short cpphy_adm_get_new_vid(cpphy_mdio_t  *mdio,
                                     unsigned char  device);
void cpphy_adm_set_default_vid(phy_number_t    phy_number,
                               unsigned char   device, 
                               unsigned short  portset);
cpmac_err_t cpphy_adm_set_port_vid_mapping(phy_number_t  phy_number,
                                           unsigned char device,
                                           unsigned char port);
void adm_vlan_clear(phy_number_t phy_number);
void adm_vlan_reset(phy_number_t phy_number);
void adm_config_ports(phy_number_t phy_number);
unsigned short cpphy_tantos_get_new_vid(cpphy_mdio_t  *mdio,
                                        unsigned char  device);
void adm_tantos_config_vlan_group(phy_number_t    phy_number,
                                  unsigned short  vid,
                                  unsigned short  portset,
                                  unsigned short  tagged_portset,
                                  unsigned char   port,
                                  unsigned char   FID,
                                  unsigned char   use_as_default);
void adm_tantos_config_ports(phy_number_t phy_number);
void cpphy_tantos_set_default_vid(phy_number_t   phy_number,
                                  unsigned char  device, 
                                  unsigned short portset);
void cpphy_adm_update_hw_status(phy_number_t phy_number, struct net_device_stats *stats);
cpmac_err_t adm_add_port_to_wan(phy_number_t   phy_number, 
                                unsigned char  port, 
                                unsigned short vid);
#if defined(CONFIG_AR9)
void adm_tantos_ar9_vlan_clear(phy_number_t phy_number);
void adm_tantos_ar9_config_vlan_group(phy_number_t    phy_number,
                                      unsigned short  vid,
                                      unsigned short  portset,
                                      unsigned short  tagged_portset,
                                      unsigned char   port,
                                      unsigned char   FID,
                                      unsigned char   use_as_default);
void adm_tantos_ar9_config_ports(phy_number_t phy_number);
void adm_switch_port_power_tantos_ar9(cpphy_mdio_t *mdio, 
                                      unsigned char port, 
                                      unsigned char power_on);
#endif /*--- #if defined(CONFIG_AR9) ---*/

#endif /*--- #ifndef _CPPHY_ADM6996_H_ ---*/


